;;
;; md5 - Scheme wrapper for Colin Plumb's Public Domain md5 implementation
;;
;; All code in this egg is in the Public Domain

#>#include "md5-base.c"<#
;#>#include "md5-ssl.c"<# ;an alternative coding

(module md5-api

(;export
  name version
  context-size digest-length block-length
  init update final raw-update)

(import scheme
  (chicken base)
  (chicken foreign))

;;

(define name 'md5)
(define version "1.0.0")

;;

(define-foreign-variable *digest-length* size_t "MD5_DIGEST_SIZE")
(define-foreign-variable *block-length* size_t "MD5_BLOCK_SIZE")
(define-foreign-variable *context-size* size_t "sizeof(struct MD5Context)")

(define context-size *context-size*)
(define digest-length *digest-length*)
(define block-length *block-length*)

;;

(define init (foreign-lambda void MD5Init c-pointer))
(define update (foreign-lambda void MD5Update c-pointer scheme-pointer size_t))
(define final (foreign-lambda void MD5Final c-pointer scheme-pointer))
(define raw-update (foreign-lambda void MD5Update c-pointer c-pointer size_t))

) ;md5-api
